/**
 * This is the main cog_test program file.
 */
#include "simpletools.h"                      // Include simpletools library 
#include "cog_test.h"

/* control block for cogA */
struct {
    unsigned stack[STACK_SIZE_A];
    volatile Mailbox_t m;
} parA;

/* control block for cogB */
struct {
    unsigned stack[STACK_SIZE_B];
    volatile Mailbox_t m;
} parB;

/* start cogA */
void startA(volatile void *parptr)
{
    extern unsigned int _load_start_cogA_cog[];
    parA.m.started = 0;
#if defined(__PROPELLER_XMM__)
    load_cog_driver_xmm(_load_start_cogA_cog, 496, (uint32_t *)parptr);
#else
    cognew(_load_start_cogA_cog, parptr);
#endif
}

/* start cogB */
void startB(volatile void *parptr)
{
    extern unsigned int _load_start_cogB_cog[];
    parB.m.started = 0;
#if defined(__PROPELLER_XMM__)
    load_cog_driver_xmm(_load_start_cogB_cog, 496, (uint32_t *)parptr);
#else
    cognew(_load_start_cogB_cog, parptr);
#endif
}

int main(void)
{
    pause(1000);  

/* start the A cog */
    print("starting cogA\n");
    startA(&parA.m);
    while(parA.m.started == 0)
      ;
    print("A: %s\n",parA.m.cog_message);
    parA.m.started = 0;

/* start the B cog */
    print("starting cogB\n");
    startB(&parB.m);
    while(parB.m.started == 0)
      ;
    print("B: %s\n",parB.m.cog_message);
    parB.m.started = 0;

    print("Now running\n");
 
/* loop forever */
    while(1) {
        print("A: %s %11u\n",parA.m.cog_message, parA.m.started);
        print("B: %s %11u\n",parB.m.cog_message, parB.m.started);
        pause(500);
    }
    return 0;
}